
import java.awt.*;
import java.awt.event.*;

public class Snake extends Frame
{
	static final int DIM =  50;
	static final int SIZE = 10;
	static final int INIT = 5;
	private Queue snake;
	private int map[][];
	private int grow;
	private int x = 1;
	private int y = DIM/2-1;
	private int horiz = 1;
	private int vert = 0;
	private Thread t;
	private int score = 0;

	public static void main(String args[])
	{
		Snake s = new Snake();
		s.setVisible( true );
	}

	public Snake()
	{
		snake = new ArrayQueue();
		
		map = new int[DIM][DIM];
		for(int i = 0; i < DIM; i++)
			for(int j = 0; j < DIM; j++)
				map[i][j] = 0;
		setSize(DIM*SIZE+40,DIM*SIZE+40);
		grow = INIT;
		for(int i = 0; i < INIT; i++)
			move();
		addapple();
		repaint();
		t = new Thread()
			{
			public void run()
			{
			   while (true)
			   {
			      try { sleep(200); } catch(Exception e) {}
			      move();
			      repaint();
			   }
			}
			};
		t.start();
		addWindowListener(new WindowAdapter()
			{
			   public void windowClosing(WindowEvent e)
			   {
			      System.exit(0);
			   }
			});
		addKeyListener(new KeyAdapter()
			{
			   public void keyPressed(KeyEvent ke)
			   {
			      int k = ke.getKeyCode();
			      if (k == KeyEvent.VK_UP)
			      { vert = -1; horiz = 0; }
			      else if (k == KeyEvent.VK_DOWN)
			      { vert = 1; horiz = 0; }
			      else if (k == KeyEvent.VK_LEFT)
			      { vert = 0; horiz = -1; }
			      else if (k == KeyEvent.VK_RIGHT)
			      { vert = 0; horiz = 1; }
			   }
			});	
	}
	
	public void paint(Graphics g)
	{
		for(int i = 0; i < DIM; i++)
			for(int j = 0; j < DIM; j++)
				if (map[i][j]==1)
					g.drawOval(i*SIZE+20,j*SIZE+20,SIZE,SIZE);
				else if (map[i][j]==2)
					g.fillOval(i*SIZE+20,j*SIZE+20,SIZE,SIZE);
	}
	
	public void move()
	{
		x = (x + horiz + DIM ) % DIM;
		y = (y + vert + DIM) % DIM;
		Point p = new Point(x,y);
		snake.enqueue(p);
		if (map[x][y] == 2)
		{
			score += 5;
			grow = 5;
			addapple();
		}
		else if (map[x][y] == 1)
		{
			System.out.println("Your score is "+score);
			System.exit(0);
		}
		map[x][y] = 1;
		if (grow == 0)
		{
			Point rem = (Point) snake.dequeue();
			map[rem.getX()][rem.getY()] = 0;
		}
		else
			grow--;
	}
	
	public void addapple()
	{
		boolean foundempty = false;
		while (!foundempty)
		{
			int x = (int) (Math.random()*DIM);
			int y = (int) (Math.random()*DIM);
			if (map[x][y] == 0)
			{
				map[x][y] = 2;
				// System.out.println(x+","+y);
				foundempty = true;
			}
		}	
	}
}

